#define uchar unsigned char
#define uint32 unsigned int

//
// Use one of these to turn on the version you like
//
// #define USE_RESTRICTED_WORDS
#define USE_RESTRICTED_BYTES
// #define USE_UNRESTRICTED_CAST_TO_WORDS

#ifdef USE_RESTRICTED_WORDS
#define COPY_WORD(dst,src,i)	\
	*(dst+((i)/4)) = *(src+((i)/4));

#elif defined(USE_RESTRICTED_BYTES)
#define COPY_WORD(dst,src,i)	\
	*(dst+(i  )) = *(src+(i  )); \
	*(dst+(i+1)) = *(src+(i+1)); \
	*(dst+(i+2)) = *(src+(i+2)); \
	*(dst+(i+3)) = *(src+(i+3));


#elif defined(USE_UNRESTRICTED_CAST_TO_WORDS)
#define COPY_WORD(dst,src,i)	\
	*(uint32*)(dst+(i)) = *(uint32*)(src+(i));

#endif

#define COPY_QUADWORD(dst,src,i)\
	COPY_WORD(dst,src,i)\
	COPY_WORD(dst,src,i+4)\
	COPY_WORD(dst,src,i+8)\
	COPY_WORD(dst,src,i+12)

#define COPY64(dst,src,i)\
	COPY_QUADWORD(dst,src,i)\
	COPY_QUADWORD(dst,src,i+16)\
	COPY_QUADWORD(dst,src,i+32)\
	COPY_QUADWORD(dst,src,i+48)

#define COPY256(dst,src,i)\
	COPY64(dst,src,i)\
	COPY64(dst,src,i+64)\
	COPY64(dst,src,i+128)\
	COPY64(dst,src,i+192)

static void copyK(uchar *d, uchar const *s)
{
#ifdef USE_RESTRICTED_WORDS
#define SRC w_src
#define DST w_dst
	uint32       * __restrict__ w_dst = d;
	uint32 const * __restrict__ w_src = s;

#elif defined(USE_RESTRICTED_BYTES)
#define SRC b_src
#define DST b_dst
	uchar       * __restrict__ b_dst = d;
	uchar const * __restrict__ b_src = s;

#else
#define SRC s
#define DST d
#endif
	COPY256(DST,SRC,0)
	COPY256(DST,SRC,256)
	COPY256(DST,SRC,512)
	COPY256(DST,SRC,768)
}
	
void strideKcp(uchar *destination, uchar const *source, int count, int stride)
{
	int i;
	for( i=0; i<count; i++ )
		copyK(&destination[i*stride],&source[i*1024]);
}

