#include <stdio.h>
#include <stdlib.h>

#define CHUNKSIZE 1024
#define TEST_BUFSIZE (16*1024*1024)
#define STRIDE 3
#define ITERATIONS 4096

#define uchar unsigned char
#define uint32 unsigned int
void strideKcp(uchar *destination, uchar const *source, int count, int stride);

int
main()
{
  unsigned char *baseptr, *roundptr, *dstptr;
  unsigned long bytecount, chunkcount, i;

  baseptr = malloc(TEST_BUFSIZE);
  roundptr= (unsigned char*)((unsigned long)(baseptr + (CHUNKSIZE-1)) & ~(CHUNKSIZE-1)); 

  bytecount = TEST_BUFSIZE - (roundptr-baseptr);
  chunkcount = bytecount/CHUNKSIZE;
  chunkcount /= (STRIDE+1);

  if (chunkcount == 0) {
    printf("couldn't allocate %d bytes of memory for the test\n", TEST_BUFSIZE);
    exit(1);
  }

  printf ("%d iterations, copying %ld %d-byte chunks, destination stride %d\n",
  	ITERATIONS, chunkcount, CHUNKSIZE, STRIDE);

  dstptr = roundptr+chunkcount*CHUNKSIZE;

  for (i=0; i<ITERATIONS; i++)
    strideKcp(dstptr, roundptr, chunkcount, STRIDE);

  printf ("done\n");
  return(0);
}
